Fix for KODIAK07.MOD!  (this is KODIAK08.MOD)
Kodiak #1 @6855
Sun Dec 01 14:10:40 1991
Mod Name: KODIAK08.MOD                      Date: 12/01/91
Version: 4.12                               Files Affected: BBSUTL.C ,
Difficulty: MEDIUM                                       UTILITY.C,
Description: This mod is an addition to MLNET100.MOD by Dart Vader.  This
	     is the FIX for KODIAK07.MOD.  To Be able to use this fix, you
	     will HAVE to have MLNET100 and KODIAK07.  Both files are
	     available on my board, if you can't find them.
	     THIS is a TOTAL re-write of void getuser, plus some minor
	     changes in int finduser in UTILTIY.C.

Disclaimer: I am not responsible if it messes anything up, as I don't know
what other mods you might have installed.  I just know that it has been
thoroughly tested on my board and The Downeaster Alexa, here in the 618 area
code.  We are both running WWIV v4.12

/**************************************************************************/
/* Just BLOCK READ (^K^R) in void getuser into your FIRST systems BBSUTL.C*/
/**************************************************************************/

void getuser()
{
  char s[81],s2[81],s1[81];
  int ok,count,net_only,ans;
  long l;

  thisuser.sysstatus &= (~sysstatus_ansi);
  net_only=1;
  if (syscfg.netlowtime!= syscfg.nethightime) {
    if (syscfg.nethightime>syscfg.netlowtime) {
      if ((timer()<=(syscfg.netlowtime*60.0)) || (timer()>=(syscfg.nethightime*60.0)))
        net_only=0;
    } else {
      if ((timer()<=(syscfg.netlowtime*60.0)) && (timer()>=(syscfg.nethightime*60.0)))
        net_only=0;
    }
  } else
    net_only=0;
  count=0;
  ok=0;
  checkit=1;
  okmacro=0;
  if ((!net_only) && (incom)) {
    sprintf(s,"%swelcome.ans",syscfg.gfilesdir);
    if (exist(s)) {
      nl();
       outchr('\x0c');
      nl();
#ifdef OLD
      outstr("Can you support ANSI graphics? ");
      thisuser.sysstatus=0;
      ans=yn();
#else
      ans=check_ansi();
#endif
      if (ans)
        printfile("welcome.ans");
      else
	printfile("welcome.msg");
    } else
      printfile("welcome.msg");
  }
  ansic(0);
  do {
    nl();
    if (net_only) {
      pl("This time is reserved for net-mail ONLY."); nl();
      pl("Please try calling back again later."); nl();
    } else
      prt(3,"Enter your User Name or Number."); nl();
      prt(3,"Or enter NEW if you are a new user."); nl();
      ok=0;
    outstr("NN: "); /* DON'T change the NN: prompt. */
    mpl(30);
    input(s,30);
    usernum=finduser(s);
    if ((net_only) && (usernum!=-2))
      usernum=0;
    if (usernum>0) {
      read_user(usernum,&thisuser);
      realsl=thisuser.sl;
      topscreen();
      ok=1;
      outstr("PW: ");
      mpl(8);
      echo=0;
      input(s,8);
      strcpy(s1,"  Tried password: ");
      strcat(s1,s);
      if (strcmp(s,thisuser.pw)!=0)
	ok=0;
      if ((syscfg.sysconfig & sysconfig_free_phone)==0) {
	outstr("PH: ###-###-");
	mpl(4);
        echo=0;
	input(s,4);
	strcat(s1,"  Tried PH: ");
	strcat(s1,s);
        if (strcmp(s,&thisuser.phone[8])!=0) {
          ok=0;
          if ((strlen(s)==4) && (s[3]=='-')) {
            nl();
            pl("!! Enter the LAST 4 DIGITS of your phone number ONLY !!");
            nl();
          }
        }
      }
      if ((thisuser.sl==255) && (incom) && (ok)) {
	outstr("SY: ");
	mpl(20);
        echo=0;
        input(s,20);
        if (strcmp(s,syscfg.systempw)!=0)
          ok=0;
      }
      echo=1;
      if (ok) {
        changedsl();
      } else {
        ++thisuser.illegal;
        write_user(usernum,&thisuser);
        close_user();
        nl();
	pl("\7ILLEGAL LOGON\7"); nl();
        nl();
	strcpy(s,"### ILLEGAL LOGON for ");
	strcat(s,nam(&thisuser,usernum));
	strcat(s,s1);
        sl1(0,s);
	usernum=0;
      }
    } else
      if (usernum==-1) {
        newuser();
        ok=1;
      } else
        if (usernum==0) {
	  if (net_only)
	    nl();
	  else
	    pl("Unknown User."); nl();
        } else
	  if (usernum==-2) {
	    if (incom) {
	      time(&l);
                sprintf(s,"NETWORK /B%u /T%ld",modem_speed,l);
              save_status();
	      run_external1(s);
	      get_status();
	      hangup=1;
              dtr(0);
              global_xx=0;
              wait(1.0);
              dtr(1);
              wait(0.1);
	      cleanup_net();
	      imodem();
	    }
	    hangup=1;
	  } else
	    if (usernum==-3) {
	      if (incom)
	       hangup=1;
	      dtr(0);
	    }
	    if (usernum==-4) {
	       if (incom) {
	       usernum=0;
	       sprintf(s,"WWIVLINK.BAT /B%u",modem_speed);
	       save_status();
	       shrink_out(s,0,0,1,1);
	       run_external1(s);
	       get_status();
	       hangup=1;
	       dtr(0);
	       global_xx=0;
	       wait(1.0);
	       dtr(1);
	       wait(0.1);
	       cleanup_net();
	       imodem();
	     }
	     hangup=1;
	    } else
	    if (usernum==-5) {
	       if (incom) {
	       usernum=0;
	       sprintf(s,"WWIVCONN.BAT /B%u",modem_speed);
	       save_status();
	       shrink_out(s,0,0,1,1);
	       run_external1(s);
	       get_status();
	       hangup=1;
	       dtr(0);
	       global_xx=0;
	       wait(1.0);
	       dtr(1);
	       wait(0.1);
	       cleanup_net();
	       imodem();
	     }
	     hangup=1;
	    }
  } while ((!hangup) && (!ok) && (++count<3));
  if (count==3)
    hangup=1;
  checkit=0;
  okmacro=1;
  if ((!hangup) && (usernum>0) && (thisuser.restrict & restrict_logon) &&
    (strcmp(date(),thisuser.laston)==0) && (thisuser.ontoday>0)) {
    nl();
    pl("Sorry, you can only logon once per day.");
    nl();
    hangup=1;
  }
}

/********************************************/
/* Now search for int finduser in UTILITY.C */
/********************************************/

unsigned int finduser(char *s)
{
  int un;
  smalrec *sr;
  userrec u;

  if (strcmp(s,"NEW")==0)
    return(-1);
* if (strcmp(s,"!-@NETWORK@-!")==0)
#   return(-2);
# if (strcmp(s,"!-@REMOTE@-!")==0)
#   return(-3);
# if (strcmp(s,"@-!NETWORK!-@")==0)
#   return(-4);
- if (strcmp(s,"@-@REMOTE@-@")==0)   /* delete this line! */
-   return(-5)                       /* delete this line! */
# if (strcmp(s,"@-@NETWORK@-@")==0)
=   return(-5);                      /* change this line */
				     /* changed the (-6);to (-5); */
# if ((un=atoi(s))>0) {
#   read_user(un,&u);
#   if (u.inact & inact_deleted)
#     return(0);


That's it!  Just hit F-9 and recompile the two 'C' files.

Now you will have to make a NEW macro to give to the network boards that
CALL YOUR BOARD. The following it the macro file. (this is the macro for
the THIRD SYSTEM ONLY!)
----------------------------M2.NET-------------------------------------------
DEBUG ""
DIAL "%2"
SEND "^M~ ^M~ ^M~ ^M~ ^M~ ^M~ ^M~ ^M~ ^M~ {"
WAITFOR "NN:"
TIMEOUT "10"
SEND "@-@NETWORK@-@{"
-------------------------End of M2.NET---------------------------------------
Now here is the macro to give to the network boards to call your SECOND
system.  I called it M1.NET.

----------------------------M1.NET-------------------------------------------
DEBUG ""
DIAL "%2"
SEND "^M~ ^M~ ^M~ ^M~ ^M~ ^M~ ^M~ ^M~ ^M~ {"
WAITFOR "NN:"
TIMEOUT "10"
SEND "@-!NETWORK!-@{"
---------------------------End of M1.NET-------------------------------------
Just give the two macro files to the network board that calls your SECOND
SYSTEM (M1.NET) and the other (M2.NET) to the network board that calls your
THIRD SYSTEM.  You will NOT need a macro for your first system though.

Then just have the network boards just put a %1 in their callout.net file
(if they connect with your SECOND SYSTEM)

or

just have them put a %2 in their callout.net file (if they connect with
your THIRD SYSTEM).

-----------------------------------------------------------------------------

I fully support all of my mods.  I am sorry about KODIAK07.MOD having that
slight problem in it.  I totally re-wrote this new void getuser(), and I
have tested out everything.  It works GREAT!

If you have any problems, please let me know.  I would be glad to help out
anyone.  Also, if you need the MLNET100.MOD or KODIAK07.MOD (since you need
them both for this to work, just call my board.  I have them both.

We also have AUTO SYSOP VALIDATION!

Special thanks to The Strager for helping me beta test this and get
everything working.  Also to Dart Vader for his MLNET100.MOD. If you use
this MOD, please send me a note at one of my net addresses.  Thanks!


Kodiak
The Mansion BBS  (618)931-7814  300/1200/2400  AUTO SYSOP VALIDATION!
      WWIVnet @6855  IceNET @6850  WWIVconnect @26855


